# -*- coding: utf-8 -*-
"""
Script to export boundary condition nodes (BCN) and boundary condition nodestrings (BCS).
Needed modules: read_2dm.py (separate script)
"""

import read_2dm
import shapefile
import glob
import re
import numpy as np

smsFiles=glob.glob(r'c:\lzi\Projekty\DE_HydroAs\work\HydroAs_2dm'+r'\*.2dm')
for sms in smsFiles:
    p=read_2dm.read_sms_mesh(sms,True)

    f=open(sms,'r')
    lines=f.readlines()
    f.close()
    
    bcn=[]
    bcs=[]
    countNS=1
    shpNamePre=sms.split('\\')[-1][:-4].replace(' ','_')
    outputFolder=r'c:\lzi\Projekty\DE_HydroAs\work\HydroAs_2dm\bcn_bcs'
    outputPath=outputFolder+'\\'+shpNamePre
    
    for l in lines:
        l=l.strip()
        #Saving all BCN as list
        if l.startswith('BCN '):
            a=re.split(' +',l)
            if a[2]=='2':
                bcn.append([int(a[1]),int(a[2]),-9999])
            else:
                bcn.append([int(a[1]),int(a[2]),float(a[3])])
        #Saving all BCS as list
        elif l.startswith('BCS ') and countNS <= len(p[6]):
            b=re.split(' +',l)
            bcsv=[]
            for v in range(1,len(b)):
                if v <= 1:
                    bcsv.append(int(b[v]))
                else:
                    bcsv.append(float(b[v]))
            bcs.append(bcsv)
            
            #Count to exclude BCS for time series. Number of BCS should be the same as number of node strings from *2dm file  
            countNS += 1
    
    #Saving BCN as point shapefile               
    shpBCN=shapefile.Writer(shapeType=1)
    shpBCN.field('id_2dm','N')
    shpBCN.field('type','N')
    shpBCN.field('value','N',10,3)
    for j in bcn:
        index=np.where(p[1]==j[0])[0][0]
        shpBCN.record(j[0],j[1],j[2])
        shpBCN.point(p[2][index],p[3][index])              
    shpBCN.save(outputPath+'_bcn.shp')
                    
    #Saving BCS as line shapefile
    shpBCS=shapefile.Writer(shapeType=3)
    shpBCS.field('id','N')
    shpBCS.field('type','N')
    shpBCS.field('value','C',250)
    for h in bcs:
        value=", ".join(str(x) for x in h[2:])
        shpBCS.record(h[0],h[1], value)
        ndStr=p[6][h[0]-1]
        part=[]
        for nd in ndStr:
            index=np.where(p[1]==nd)[0][0]
            part.append([p[2][index],p[3][index]])
        shpBCS.line(parts=[part])     
    shpBCS.save(outputPath+'_bcs.shp')
